<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2012 Andre Leinhos                                        |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by Andre Leinhos. See    |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
*/
function dell_dot($value){
	return ereg_replace("\.","",$value);
}


function split_on_dot($servername) {
	    $serverstring = explode(".", $servername);
		  return $serverstring[0];
}

function is_ip($string){  
    if (preg_match('/\b(?:\d{1,3}\.){3}\d{1,3}\b/',$string)) {
        return TRUE;
     }else{
      return FALSE;
     }
}
function window_alert($ausg){ /* Diese Funktion simuliert JavaScript window.confirm() */ 
  $a1 = "\n <script type=\"text/javascript\"> "; 
  $a2 = "\n alert(\""; 
  $a3 = "\"); "; 
  $a4 = "\n </script> \n"; 
  $ausgabe = $a1 . $a2 . $ausg . $a3 . $a4; 
  print $ausgabe;
}


/* array_to_string - change array to string with option format the returnvalue can be formated 
		@arg $array - array for change
		@arg $textformat - em, var, blockquote etc.
		@arg $delimiter - Delipiter to split array
*/
function array_to_string($array, $textformat = "",$delimiter = ",") {

	if (is_array($array)) {
		$tag_front= "";
		$tag_back = "";

		/* formating output */
		if ($textformat <> "") {
			$tag_front = "<".$textformat.">";
			$tag_back = "</".$textformat.">";
		}
			
		/* delimiter to split arry */
			$return_value = implode($delimiter, $array);
			$return_value = $tag_front.$return_value.$tag_back;
	return $return_value;
	} // is_array
}

function test_poller_server($hostname,$server_name){
  $f_multipollerserver_name = gethostbyaddr($hostname);           
     if (is_ip($f_multipollerserver_name) == FALSE){            
        $f_multipollerserver_name = split_on_dot($f_multipollerserver_name);
       }
     if (strstr(htmlspecialchars($f_multipollerserver_name),htmlspecialchars($server_name)) == FALSE){
      return 0;
      }else{
      return 1;
      }
}

function date_time($timestamp){
	if ($timestamp > 0){
				$time_value = date("d.M.Y - H:i:s",$timestamp);
				return $time_value;
			}else{
				return $time_value;
			}
} //date_time


function updatelog($log_values,$cp_error = 0,$new_version){
	if (strstr($log_values,'Reversed')) {
		cacti_log("ERROR: The Plugin Multi-Pollerserver notifies one or more errors at updateprocess. $log_values", FALSE, "POLLER");
	} elseif (count($log_values) == 0) {
		cacti_log("ERROR: The Plugin Multi-Pollerserver notifies the patches are not found.", FALSE, "POLLER");
	} elseif ($cp_error == 1) {
		cacti_log("ERROR: The Plugin Multi-Pollerserver notifies the backup of patching files not done.", FALSE, "POLLER");
	} else {
		db_execute("UPDATE plugin_config SET version = '$new_version' WHERE directory = 'multipollerserver'");
		cacti_log("STATS: The Plugin Multi-Pollerserver is now up to date. New version: $new_version $log_values", FALSE, "POLLER");
	}
} // updatelog


function uninstalllog($cp_error){
		if ($cp_error == 1) {
		cacti_log("ERROR: The Plugin Multi-Pollerserver notifies the original files could not be discoverd. Look at 'Cacti_Path'/plugins/multipollerserver/org_files. ", FALSE, "POLLER");
		}else {
		cacti_log("STATS: The Plugin Multi-Pollerserver is completely uninstalled.", FALSE, "POLLER");
		}
} // uninstalllog

function multipollerserver_database_exist ($serach_table) {
	$exist = false;
	$table_exist = db_fetch_cell("SHOW TABLES LIKE '$serach_table'");
	
	$exist = ($table_exist == "" ) ? false : true ;
	return $exist;
}//multipollerserver_database_exist ()


# SHOW FIELDS FROM host 
function database_field_exist ($serach_table,$search_field) {
	
	$fields = db_fetch_assoc("SHOW COLUMNS FROM $serach_table");

		for ($i = 1 ; $i <= sizeof($fields); $i++) {
			if ($fields[$i]["Field"] == $search_field)
				return true;
		} // for
}//multipollerserver_database_exist ()



function multipollerserver_setup_database () {

db_execute("CREATE TABLE IF NOT EXISTS `poller_server` (
		`id` int(3) NOT NULL auto_increment,
		`name` varchar(100) NOT NULL,
		`hostname` varchar(50) NOT NULL,
		`poller_lastrun` int(50) default '0',
		`stats_poller` varchar(200) default '0',
		`aktive` char(2) default NULL,
		`availability_method` smallint(5) unsigned NOT NULL default '3',
		`ping_method` smallint(5) unsigned default '3',
		`ping_port` int(12) unsigned default '33439',
		`ping_timeout` int(12) unsigned default '500',
		`ping_retries` int(12) unsigned default '2',
		PRIMARY KEY  (`id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;");
} //multipollerserver_setup_database


//compatibility for plugin update
function multipollerserver_version () {
  return plugin_multipollerserver_version ();
} //multipollerserver_version


// Vorbereitung fr weiter Settingsfunktionen
function multipollerserver_config_settings () {
	global $tabs, $settings;
	$tabs["server"] = "multipollerserver";
    	
	 $temp = array(
		"poller_server_header" => array(
			"friendly_name" => "multipollerserver Options",
			"method" => "spacer",
			),
    "poller_server" => array(
			"friendly_name" => "Server Name",
			"description" => "Name of servers",
			"method" => "textbox",
			"max_length" => 255,
			),
   );    
  
  if (isset($settings["server"]))
		$settings["server"] = array_merge($settings["server"], $temp);
	else
		$settings["server"]=$temp;
    unset($temp); 
} //multipollerserver_config_settings

function multipollerserver_include_multipollerserver () {  //Dropdown multipollerserver in device einbinden
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();

		foreach ($fields_host_edit2 as $f => $a) {
			$fields_host_edit3[$f] = $a;
				if ($f == 'device_threads') {
					if (is_fallbackmode() == FALSE) { // fallback_poller_id = 0
						$fields_host_edit3["poller_id"] = array(
								"method" => "drop_sql",
								"friendly_name" => "Poller Server",
								"description" => "Choose what type of host, host template this is. The host template will govern what kinds of data should be gathered from this type of host.",
								"value" => "|arg1:poller_id|",
								"none_value" => "None",
								"sql" => "select id,name from poller_server order by id",
							);
						}
					else{
							$fields_host_edit3["poller_id "] = array(
								"friendly_name" => "Poller Server",
								"description" => "Choose what type of host, host template this is. The host template will govern what kinds of data should be gathered from this type of host. <br>
																		<FONT COLOR=red> This option where disabled with plugin multipollerserver version 0.22b!<br>
																		After install the new Version of the plugin for cacti will be enabled this option.</FONT>",
								"method" => "textbox",
								"value" => "NONE",
								"max_length" => 255,
								);
						}//if (is_fallbackmode()
				}//if ($f == 'device_threads')
			}// foreach
	  $fields_host_edit = $fields_host_edit3;
	
}//multipollerserver_include_multipollerserver

function multipollerserver_api_device_save ($save) {
	$save["poller_id"]	= form_input_validate($_POST["poller_id"], "poller_id", "", true, 3);
	
	if ($save["poller_id"] <> ""){
			db_execute("UPDATE host SET `poller_id` = '".$save['poller_id']."' WHERE `id` = '".$_POST['id']."'");
	}
	return $save;
} //multipollerserver_api_device_save

/* update the poller_iten table with the current pollerserver_id*/
function update_poller_item ($host_id, $poller_id) {
	if (($host_id <> "") AND ($poller_id <> "")){
			db_execute("UPDATE poller_item SET `poller_id` = '".$poller_id."' WHERE `host_id` = '".$host_id."'");
			# update the hostcount on multipollerserver overview
			update_hostcount();
	}
} //update_poller_item

function update_hostcount() {
	
	$pollerserver_ids = db_fetch_assoc("SELECT `id` FROM `poller_server`");

		for ($i = 0 ; $i <= sizeof($pollerserver_ids)-1; $i++) {
				$hostcount = db_fetch_cell("SELECT count(`id`) FROM `host` WHERE `poller_id` = '".$pollerserver_ids[$i]["id"]."'");
				db_execute("UPDATE poller_server SET `hostcount` = '".$hostcount."' WHERE `id` = '".$pollerserver_ids[$i]["id"]."'");
		} // for

} //update_hostcount

function pollerid_to_pollername($poller_id) {
	if ($poller_id == 0){
			$pollerserver_name = "NONE";
		}else{
			$pollerserver_name = db_fetch_cell("SELECT `name` FROM `poller_server` WHERE `id` = $poller_id");
		}
		return $pollerserver_name;
} //pollerid_to_pollername

function pollername_to_pollerid($pollername){
	if ($pollername == "NONE"){
			$pollerserver_name = "0";
		}else{
			$pollerserver_name = db_fetch_cell("SELECT `id` FROM `poller_server` WHERE `name` = '$pollername'");
		}
		return $pollerserver_name;
}//pollername_to_pollerid


/* function for poller.php*/
function check_backuppollerserver($server_remote_name){
	
	$poller_server_id = db_fetch_cell("SELECT id FROM poller_server WHERE name ='$server_remote_name' AND aktive = 'on'");
	$poller_backup_server_id = db_fetch_cell("SELECT backup_poller_id FROM poller_server WHERE name ='$server_remote_name' ");
	
	if ($poller_backup_server_id > 0) { // = 0 is NONE
			$poller_backup_server_name = db_fetch_cell("SELECT name FROM poller_server WHERE id ='$poller_backup_server_id' ");
			$poller_backup_server_lastrun = db_fetch_cell("SELECT poller_lastrun  FROM poller_server WHERE id ='$poller_backup_server_id' ");
			$poller_backup_server_mode = db_fetch_cell("SELECT backup_mode FROM poller_server WHERE id ='$poller_backup_server_id' ");
	
			$sum_of_backup_mode = db_fetch_cell("SELECT SUM(`backup_mode`) FROM poller_server");
			
			$now_time = time();
			if(($now_time - $poller_backup_server_lastrun > 420) AND ($poller_backup_server_mode == 0) AND ($sum_of_backup_mode == 0)){
					db_execute("UPDATE `host` SET `backup_poller_id` = `poller_id`,`poller_id` = $poller_server_id  WHERE `poller_id` = $poller_backup_server_id");
					db_execute("UPDATE `poller_server` SET `backup_mode` = '1' WHERE `id` = $poller_backup_server_id ");
										/* update the poller_iten table with the current pollerserver_id*/
					$array_host_id = db_fetch_assoc("SELECT `id` FROM host WHERE poller_id = $poller_server_id");
						if (sizeof($array_host_id)) {
							foreach($array_host_id as $host_id) {
							update_poller_item ($host_id["id"], $poller_server_id);
							}
					}
				cacti_log("WARNING: Pollerserver: ".$server_remote_name." takes over the polling for Pollerserver ".$poller_backup_server_name."'", TRUE);
			}elseif(($now_time - $poller_backup_server_lastrun > 420) AND ($poller_backup_server_mode == 0) AND ($sum_of_backup_mode > 0)){
						cacti_log("WARNING: SORRY for Pollerserver: ".$poller_backup_server_name." is no backupprocess possible, only one Pollerserver can run in Backup Mode!", TRUE);
			}elseif(($now_time - $poller_backup_server_lastrun < 420) AND ($poller_backup_server_mode == 1)){
					/* update the poller_iten table with the current pollerserver_id*/
					$array_host_id = db_fetch_assoc("SELECT `id` FROM host WHERE backup_poller_id = $poller_backup_server_id");
					if (sizeof($array_host_id)) {
							foreach($array_host_id as $host_id) {
								update_poller_item ($host_id["id"], $poller_backup_server_id);
							}
						}
					db_execute("UPDATE `host` SET `poller_id` = `backup_poller_id`,`backup_poller_id` = '0'  WHERE `backup_poller_id` = $poller_backup_server_id");
					db_execute("UPDATE `poller_server` SET `backup_mode` = '0' WHERE `id` = $poller_backup_server_id ");
					update_hostcount();
					cacti_log("WARNING: Pollerserver: ".$poller_backup_server_name." takes over the polling '", TRUE);
			}//check time diff lastpoll
		} //$poller_backup_server_id > 0
return $poller_server_id;
}//check_backuppollerserver


/* function for look fallbackmode*/
function is_fallbackmode(){
		$fallback_mode_id = db_fetch_cell("SELECT value FROM `settings` WHERE `name` = 'fallback_poller_id'");
	if ($fallback_mode_id == 1){
		return TRUE; //1
	}else{
		return FALSE; //0
	}
}//is_fallbackmode


/* check if table exists */
# @arg1 = TABLE_NAME
# @arg1 = COLUMN_NAME
function table_exists( $f_tablename,$f_columnname){
	global $database_default;
	$exist_table = db_fetch_cell("SELECT ORDINAL_POSITION FROM information_schema.COLUMNS WHERE COLUMN_NAME='$f_columnname' AND TABLE_NAME='$f_tablename' AND TABLE_SCHEMA= '$database_default'");
		if ($exist_table <> ""){
			return TRUE; //exists
			}else{
				return FALSE; //Not exists
			}
} // table_exists
?>
